searchNodes=[{"doc":"EctoRange is a tiny library that provides Ecto custom types for all Postgres Range types . The main design goal of EctoRange is to be easy to use with native Elixir types, while providing the full flexibility of Postgres Range types inside of Ecto. Postgres type Ecto.Type int4range EctoRange.Int4 int8range EctoRange.Int8 numrange EctoRange.Num tsrange EctoRange.NaiveDatetime tstzrange EctoRange.Datetime daterange EctoRange.Date Installation If available in Hex , the package can be installed by adding ectorange to your list of dependencies in mix.exs : def deps do [ { :ecto_range , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/ectorange . Alternative libraries If you're unhappy with the feature set EctoRange , there are some alternative libraries that provide similar functionality ecto_date_time_range pg_ranges","ref":"EctoRange.html","title":"EctoRange","type":"module"},{"doc":"A custom type for working with the Postgres daterange type. iex&gt; range = Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) iex&gt; cs = TestApp.Table . changeset ( % TestApp.Table { name : &quot;EctoRange.Date&quot; } , %{ range : range } ) iex&gt; cs . changes %{ range : % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } } Casting EctoRange.Date provides a couple of conveniences when casting data. All valid data will be cast into a Postgrex.Range.t/0 struct. When supplied to an Ecto.Changeset, the following types are valid Date.Range.t/0 will be treated as an inclusive range {t:date() | t:String.t/0, t:date() | t:String.t/0} can be used to express unbounded ranges, where nil represents an unbounded endpoint Postgrex.Range.t/0 will be treated as a valid range representation Loading All data loaded from the database will be normalized into an inclusive range to align with the semantics of Date.Range.t()","ref":"EctoRange.Date.html","title":"EctoRange.Date","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Date.html#embed_as/1","title":"EctoRange.Date.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Date.html#equal?/2","title":"EctoRange.Date.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive to align with the semantics of Date.Range.t() iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-02] , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-21] , upper : ~D[2021-03-01] , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Date.html#normalize_range/1","title":"EctoRange.Date.normalize_range/1","type":"function"},{"doc":"Converts valid Date.Range.t() or Date.t() tuples into a Postgrex.Range.t() iex&gt; EctoRange.Date . to_postgrex_range ( Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Date.html#to_postgrex_range/1","title":"EctoRange.Date.to_postgrex_range/1","type":"function"},{"doc":"","ref":"EctoRange.Date.html#t:date/0","title":"EctoRange.Date.date/0","type":"type"},{"doc":"A Postgres range of int4 integers. Equivalent to int4range .","ref":"EctoRange.Int4.html","title":"EctoRange.Int4","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Int4.html#embed_as/1","title":"EctoRange.Int4.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Int4.html#equal?/2","title":"EctoRange.Int4.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Int4 . normalize_range ( range ) % Postgrex.Range { lower : 1 , upper : 2 , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Int4 . normalize_range ( range ) % Postgrex.Range { lower : 2 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int4.html#normalize_range/1","title":"EctoRange.Int4.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Int4 . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int4.html#to_postgrex_range/1","title":"EctoRange.Int4.to_postgrex_range/1","type":"function"},{"doc":"A Postgres range of int8 integers. Equivalent to int8range . Allows bigint values.","ref":"EctoRange.Int8.html","title":"EctoRange.Int8","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Int8.html#embed_as/1","title":"EctoRange.Int8.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Int8.html#equal?/2","title":"EctoRange.Int8.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Int8 . normalize_range ( range ) % Postgrex.Range { lower : 1 , upper : 2 , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Int8 . normalize_range ( range ) % Postgrex.Range { lower : 2 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int8.html#normalize_range/1","title":"EctoRange.Int8.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Int8 . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int8.html#to_postgrex_range/1","title":"EctoRange.Int8.to_postgrex_range/1","type":"function"},{"doc":"A Postgres range of numeric values. Equivalent to numrange . Allows numeric values of all precisions. Returns Decimal structs when loading from the database. Watch out: Not defining the precision of your values, might cause compatibility problems with other systems in the future.","ref":"EctoRange.Num.html","title":"EctoRange.Num","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Num.html#embed_as/1","title":"EctoRange.Num.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Num.html#equal?/2","title":"EctoRange.Num.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. All upper and lower bounds are converted to %Decimal{} structs, if necessary. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Num . normalize_range ( range ) % Postgrex.Range { lower : % Decimal { coef : 1 } , upper : % Decimal { coef : 2999999999 , exp : - 9 } , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Num . normalize_range ( range ) % Postgrex.Range { lower : % Decimal { coef : 1000000001 , exp : - 9 } , upper : % Decimal { coef : 3 } , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Num.html#normalize_range/1","title":"EctoRange.Num.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Date . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Num.html#to_postgrex_range/1","title":"EctoRange.Num.to_postgrex_range/1","type":"function"}]